package it.eng.spago.services.alias;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.services.AbstractService;
import it.eng.spago.tracing.TracerSingleton;

import org.apache.commons.validator.GenericValidator;

/**
 * Retrive alias information from configuration file.
 */
public class AliasService extends AbstractService {
	/**
	 * Path for aliases in configuration file (aliases.xml).
	 */
	private static final String ALIAS_PATH = "ALIASES.ALIAS";
	
    /**
     *  Constructor for the AliasService object
     */
    public AliasService() { }


/* ######
 * nothing to "init". maintain abstractservice void method
 * ###### */

    public String getAlias(String aliasName) {
    	String configAlias = null;
        if (!GenericValidator.isBlankOrNull(aliasName)) {
        	SourceBean sbAlias = (SourceBean)ConfigSingleton.getInstance()
        		.getFilteredSourceBeanAttribute(ALIAS_PATH, "NAME", aliasName); 
	        if (sbAlias != null) {
	        	configAlias = (String)sbAlias.getAttribute("VALUE");
	        } else {
	        	TracerSingleton.log(it.eng.spago.base.Constants.NOME_MODULO, TracerSingleton.WARNING,
	        		"AliasService::getAlias: Can't find alias ["+aliasName+"] passed to tag.");
	        }//if (sbAlias != null)
        }//if (!GenericValidator.isBlankOrNull(aliasName))
        return configAlias;
   }//public String getAlias(String aliasName)

}
