/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.action;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.message.MessageBundle;

import java.util.Iterator;
import java.util.List;

import org.apache.commons.codec.binary.Base64;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Node;
import org.spagic.metadb.base.TransitionStateUtils;
import org.spagic.metadb.model.LogJournal;




public class LogsJournalAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String idJournal = (String)serviceRequest.getAttribute("idJournal");
		String type = (String)serviceRequest.getAttribute("type");
		int stateJournal = ProcessInstanceBO.getStateJournal(Long.parseLong(idJournal));
		SourceBean logJournalBean = new SourceBean("LIST");		
		List logsJournalList = ProcessInstanceBO.getLogsJournal(Long.parseLong(idJournal), type);					
		Iterator logsJournalIt = logsJournalList.iterator();
		SourceBean item = null;
		LogJournal logJournal = null;
		String stateLog = null;	
		String readonlyLog = "TRUE";
		while(logsJournalIt.hasNext()) {
			logJournal = (LogJournal)logsJournalIt.next();				
			item = new SourceBean("ITEM");
			item.setAttribute("idLog", logJournal.getIdLog());			
			
			//posso modificare solo un messaggio di input ovvero un mep di tipo ACTIVE 
			if(type == null || type.equalsIgnoreCase("")) {
				if ( TransitionStateUtils.isFaultState(stateJournal) && TransitionStateUtils.isActiveState(logJournal.getTransitionState().getIdState()))  
					readonlyLog = "FALSE";
				else
					readonlyLog = "TRUE";
			}
			item.setAttribute("readonlyLog", readonlyLog);
			
			stateLog = Integer.toString(logJournal.getTransitionState().getIdState());
			item.setAttribute("stato", MessageBundle.getMessage(stateLog, "properties.console.console"));
			if(logJournal.getLog().indexOf("PLAIN-HL7")>0){
				Document document = DocumentHelper.parseText(logJournal.getLog());
				Node plainHL7Node = document.selectSingleNode("/PLAIN-HL7");
				String base64encoded = plainHL7Node.valueOf("@base64encoded");
				String Hl7Msg = plainHL7Node.getText();
				if(base64encoded != null && base64encoded.trim().length() > 0 && Boolean.valueOf(base64encoded))
					Hl7Msg = new String(Base64.decodeBase64(Hl7Msg.getBytes()));
				item.setAttribute("log", Hl7Msg);
			}else
				item.setAttribute("log", logJournal.getLog());								
			logJournalBean.setAttribute(item);				
		} 				
		serviceResponse.setAttribute(logJournalBean);
	}

}

