/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.action;

import java.util.Iterator;
import java.util.List;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;

public class StepInstancePropertiesAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String idStepInstance = (String)serviceRequest.getAttribute("idStepInstance");
		Object flagUserProperties = serviceRequest.getAttribute("USER_PROPERTIES");
		Object flagMessageProperties = serviceRequest.getAttribute("MESSAGE_PROPERTIES");
		List propertiesList = null;
		if (flagUserProperties != null && ((String)flagUserProperties).equalsIgnoreCase("TRUE"))
			propertiesList = ProcessInstanceBO.getStepUserProperties((new Long(idStepInstance)).longValue());
		else if (flagMessageProperties != null && ((String)flagMessageProperties).equalsIgnoreCase("TRUE"))
			propertiesList = ProcessInstanceBO.getStepMessageProperties((new Long(idStepInstance)).longValue());
		
		Iterator propertiesIt = propertiesList.iterator();	
		SourceBean propertyBean = new SourceBean("PROPERTIES");
		SourceBean data = null;	
		List attributeProperties;
		String catalog = null;
		while (propertiesIt.hasNext()) {
			data = new SourceBean("PROPERTY");
			attributeProperties = (List)propertiesIt.next();
			data.setAttribute("attributo", attributeProperties.get(0));
			data.setAttribute("value", attributeProperties.get(1));
			propertyBean.setAttribute(data);
		}
		
		serviceResponse.setAttribute(propertyBean);							 				
	}

}
