package it.eng.console.audit.action;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.rmi.RemoteException;

import org.spagic.components.jobs.backupcfg.ConfigureAutomaticBackupConfigureParameters_v_0Locator;
import org.spagic.components.jobs.backupcfg.ConfigureAutomaticBackupStart_v_0Proxy;
import org.spagic.components.jobs.backupcfg.parameters.ParametersType;

import it.eng.console.util.Constants;
import it.eng.console.util.CronExpressionUtil;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago.message.MessageBundle;
import it.eng.spago.tracing.TracerSingleton;

public class UpdateConfigurationBackupProcessAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		
		String frequency = (String)serviceRequest.getAttribute(Constants.LBL_FREQUENCY);
		String expiredTime = (String)serviceRequest.getAttribute(Constants.LBL_EXPIRED_TIME);
		String autoBackup = (String)serviceRequest.getAttribute(Constants.LBL_AUTOBACKUP);
		
		ParametersType input = new ParametersType();
		input.setAuto_backup(autoBackup);
		input.setExpired_time(expiredTime);
		input.setFrequency(CronExpressionUtil.format(frequency));
		input.setSet_cfg("true");
		
		ConfigureAutomaticBackupStart_v_0Proxy cfgBackupProxy = new ConfigureAutomaticBackupStart_v_0Proxy();
		String locationCfgBackupWS = (String)ConfigSingleton.getInstance().getAttribute("CONSOLE.locationCfgBackupWS");
		cfgBackupProxy.setEndpoint(locationCfgBackupWS);
		
		try {
			ParametersType result = cfgBackupProxy.run(input);
			if (result.getSet_cfg().equalsIgnoreCase("OK"))
				serviceResponse.setAttribute("message", MessageBundle.getMessage("10013", "properties.console.messages"));
			else
				serviceResponse.setAttribute("message", MessageBundle.getMessage("10015", "properties.console.messages"));
		} catch(RemoteException re) {
			TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "UpdateConfigurationBackupAction::service:: backupdata", re);
			serviceResponse.setAttribute("message", MessageBundle.getMessage("10015", "properties.console.messages"));
			return;
		}
	}

}
