/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.process.action;

import it.eng.console.process.bo.ProcessBO;
import it.eng.console.util.DateFormatter;
import it.eng.jmx.bo.JmxBO;
import it.eng.jmx.util.JMXUtil;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;


import java.text.DateFormat;

import org.spagic.metadb.model.Process;

public class ProcessDetailAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse) throws Exception {		
		String processId = (String)serviceRequest.getAttribute("processId");
		
		Process process = ProcessBO.getProcessDetail((new Long(processId)).longValue());
		SourceBean processBean = new SourceBean("DETAIL");
		
		processBean.setAttribute("nome", process.getName());
		String descrizione = (process.getDescription() != null) ? process.getDescription() : "";
		processBean.setAttribute("descrizione", descrizione);
		
		DateFormat formatter = DateFormatter.getShortDateTimeFormat(getRequestContainer().getSessionContainer());
		String dateTemp = formatter.format(process.getStartdate());					
		processBean.setAttribute("dataInizio", dateTemp);			
		dateTemp = (process.getEnddate() != null) ? formatter.format(process.getEnddate()) : "";				
		processBean.setAttribute("dataFine", dateTemp);
					
		String version = String.valueOf(process.getProcessVersion());
		processBean.setAttribute("versione", version);
		processBean.setAttribute("stato",process.getState());
		String uddiOrg = (process.getUddiOrg()!= null) ? process.getUddiOrg() : "";		
		processBean.setAttribute("UDDIOrg", uddiOrg);
		String uddiName = (process.getUddiName()!= null) ? process.getUddiName() : "";		
		processBean.setAttribute("UDDIName", uddiName);
	
//		String serviceAssemblyName = JMXUtil.createServiceAssemblyName(process.getName(), process.getProcessVersion());
//		String jmxStatus = JmxBO.isStarted(serviceAssemblyName);
//		processBean.setAttribute("status", jmxStatus);
		
		serviceResponse.setAttribute(processBean);
	}

}
