/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.tag.menu;

import it.eng.console.util.Constants;
import it.eng.spago.message.MessageBundle;
import it.eng.spago.tracing.TracerSingleton;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class ProcessInstanceListMenuTag extends TagSupport {
	
    public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "ProcessInstanceListMenuTag::doStartTag:: invocato");
        if(pageContext == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
                "ProcessInstanceListMenuTag::doStartTag:: pageContext nullo");
            throw new JspException("pageContext nullo");
        } 
        HttpServletRequest httpRequest = null;
        try {
            httpRequest = (HttpServletRequest) pageContext.getRequest();
        } catch(Exception ex) {
            TracerSingleton.log(
            		Constants.project, TracerSingleton.CRITICAL, "ProcessInstanceListMenuTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        if(httpRequest == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ProcessInstanceListMenuTag::doStartTag:: httpRequest nullo");
            throw new JspException("httpRequest nullo");
        } 
        String context = httpRequest.getContextPath();
        
        StringBuffer output = new StringBuffer(); 
        output.append("<div style=\"position:absolute;right:50px;\">\n");
        output.append("<a href=\"" + context + "/ProcessSearchAction.action?backup=TRUE\">\n");
        output.append("<img src=\"" + context + "/images/console/backup.png\"\n");
        output.append("title=\"" + MessageBundle.getMessage("backup", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("backup", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        output.append("<div style=\"position:absolute;right:82px;\">\n");
        output.append("<a href=\"" + context + "/ProcessSearchAction.action?restart=TRUE\">\n");
        output.append("<img src=\"" + context + "/images/console/startAll.gif\"\n");
        output.append("title=\"" + MessageBundle.getMessage("restart", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("restart", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        output.append("<div style=\"position:absolute;right:114px;\">\n");
        output.append("<a href=\"" + context + "/ProcessSearchAction.action\">\n");
        output.append("<img src=\"" + context + "/images/console/detail.png\"\n");
        output.append("title=\"" + MessageBundle.getMessage("advancedSearch", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("advancedSearch", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");
        
        output.append("<div style=\"position:absolute;right:146px;\">\n");
        output.append("<a href=\"#\" onclick=\"reload();return false;\">\n");
        output.append("<img src=\"" + context + "/images/console/reload.png\"\n");
        output.append("title=\"" + MessageBundle.getMessage("reload", "properties.spagic") + "\"\n");
        output.append("alt=\"" + MessageBundle.getMessage("reload", "properties.spagic") + "\"/>\n");
        output.append("</a>\n");
        output.append("</div>\n");

        try {
            pageContext.getOut().print(output.toString());
        } catch(Exception ex) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ProcessInstanceListMenuTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        return SKIP_BODY;
    } 

	/**
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "OrganizationComboTag::doEndTag:: invocato");
        return super.doEndTag();
    } 
}
